<a id="types-aiobotocore-glacier"></a>

# types-aiobotocore-glacier

[![PyPI - types-aiobotocore-glacier](https://img.shields.io/pypi/v/types-aiobotocore-glacier.svg?color=blue)](https://pypi.org/project/types-aiobotocore-glacier)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-glacier.svg?color=blue)](https://pypi.org/project/types-aiobotocore-glacier)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-glacier?color=blue)](https://pypistats.org/packages/types-aiobotocore-glacier)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.Glacier 2.3.4](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/glacier.html#Glacier)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.10.0](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-glacier docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_glacier/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-glacier](#types-aiobotocore-glacier)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `Glacier` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[glacier]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[glacier]'


# standalone installation
python -m pip install types-aiobotocore-glacier
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-glacier
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[glacier]` in your environment:

```bash
python -m pip install 'types-aiobotocore[glacier]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[glacier]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[glacier]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[glacier]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[glacier]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[glacier]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[glacier]` in your environment:

```bash
python -m pip install 'types-aiobotocore[glacier]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[glacier]` in your environment:

```bash
python -m pip install 'types-aiobotocore[glacier]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`GlacierClient` provides annotations for `session.create_client("glacier")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_glacier import GlacierClient

session = get_session()
async with session.create_client("glacier") as client:
    client: GlacierClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_glacier.paginator` module contains type annotations for all
paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_glacier import GlacierClient
from types_aiobotocore_glacier.paginator import (
    ListJobsPaginator,
    ListMultipartUploadsPaginator,
    ListPartsPaginator,
    ListVaultsPaginator,
)

session = get_session()
async with session.create_client("glacier") as client:
    client: GlacierClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_jobs_paginator: ListJobsPaginator = client.get_paginator("list_jobs")
        list_multipart_uploads_paginator: ListMultipartUploadsPaginator = client.get_paginator("list_multipart_uploads")
        list_parts_paginator: ListPartsPaginator = client.get_paginator("list_parts")
        list_vaults_paginator: ListVaultsPaginator = client.get_paginator("list_vaults")
    ```


### Waiters annotations

`types_aiobotocore_glacier.waiter` module contains type annotations for all waiters.

```python
from aiobotocore.session import get_session

from types_aiobotocore_glacier.client import GlacierClient
from types_aiobotocore_glacier.waiter import (
    VaultExistsWaiter,
    VaultNotExistsWaiter,
)

session = get_session()
async with session.create_client("glacier") as client:
    client: GlacierClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        vault_exists_waiter: VaultExistsWaiter = client.get_waiter("vault_exists")
        vault_not_exists_waiter: VaultNotExistsWaiter = client.get_waiter("vault_not_exists")
    ```


<a id="service-resource-annotations"></a>

### Service Resource annotations

`GlacierServiceResource` provides annotations for `aiobotocore.resource("glacier")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_glacier import GlacierServiceResource

session = get_session()
async with session.resource("glacier") as resource:
    resource: GlacierServiceResource
    # now resource usage is checked by mypy and IDE should provide code completion
````

<a id="other-resources-annotations"></a>

### Other resources annotations

`types_aiobotocore_glacier.service_resource` module contains type annotations
for all resources.

```python
from aiobotocore.session import get_session

from types_aiobotocore_glacier import GlacierServiceResource
from types_aiobotocore_glacier.service_resource import (
    Account,
    Archive,
    Job,
    MultipartUpload,
    Notification,
    Vault,
)

session = get_session()
async with session.resource("glacier") as resource:
    resource: GlacierServiceResource

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
    my_account: Account = resource.Account(...)
    my_archive: Archive = resource.Archive(...)
    my_job: Job = resource.Job(...)
    my_multipart_upload: MultipartUpload = resource.MultipartUpload(...)
    my_notification: Notification = resource.Notification(...)
    my_vault: Vault = resource.Vault(...)
```

<a id="collections-annotations"></a>

### Collections annotations

`types_aiobotocore_glacier.service_resource` module contains type annotations
for all `GlacierServiceResource` collections.

```python
from aiobotocore.session import get_session

from types_aiobotocore_glacier import GlacierServiceResource
from types_aiobotocore_glacier.service_resource import (
    ServiceResourceVaultsCollection,
)

session = get_session()
async with session.resource("glacier") as resource:
    resource: GlacierServiceResource

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
    vaults: glacier_resources.ServiceResourceVaultsCollection = resource.vaults
```

<a id="literals"></a>

### Literals

`types_aiobotocore_glacier.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from types_aiobotocore_glacier.literals import (
    ActionCodeType,
    CannedACLType,
    EncryptionTypeType,
    ExpressionTypeType,
    FileHeaderInfoType,
    ListJobsPaginatorName,
    ListMultipartUploadsPaginatorName,
    ListPartsPaginatorName,
    ListVaultsPaginatorName,
    PermissionType,
    QuoteFieldsType,
    StatusCodeType,
    StorageClassType,
    TypeType,
    VaultExistsWaiterName,
    VaultNotExistsWaiterName,
    GlacierServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    WaiterName,
    RegionName,
)

def check_value(value: ActionCodeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_glacier.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_glacier.type_defs import (
    AbortMultipartUploadInputRequestTypeDef,
    AbortVaultLockInputRequestTypeDef,
    AccountVaultRequestTypeDef,
    AddTagsToVaultInputRequestTypeDef,
    ResponseMetadataTypeDef,
    CSVInputTypeDef,
    CSVOutputTypeDef,
    CompleteMultipartUploadInputMultipartUploadCompleteTypeDef,
    CompleteMultipartUploadInputRequestTypeDef,
    CompleteVaultLockInputRequestTypeDef,
    CreateVaultInputAccountCreateVaultTypeDef,
    CreateVaultInputRequestTypeDef,
    CreateVaultInputServiceResourceCreateVaultTypeDef,
    DataRetrievalRuleTypeDef,
    DeleteArchiveInputRequestTypeDef,
    DeleteVaultAccessPolicyInputRequestTypeDef,
    DeleteVaultInputRequestTypeDef,
    DeleteVaultNotificationsInputRequestTypeDef,
    DescribeJobInputRequestTypeDef,
    DescribeVaultInputRequestTypeDef,
    WaiterConfigTypeDef,
    DescribeVaultOutputTypeDef,
    EncryptionTypeDef,
    GetDataRetrievalPolicyInputRequestTypeDef,
    GetJobOutputInputJobGetOutputTypeDef,
    GetJobOutputInputRequestTypeDef,
    GetVaultAccessPolicyInputRequestTypeDef,
    VaultAccessPolicyTypeDef,
    GetVaultLockInputRequestTypeDef,
    GetVaultNotificationsInputRequestTypeDef,
    VaultNotificationConfigTypeDef,
    InventoryRetrievalJobDescriptionTypeDef,
    GranteeTypeDef,
    InitiateMultipartUploadInputRequestTypeDef,
    InitiateMultipartUploadInputVaultInitiateMultipartUploadTypeDef,
    VaultLockPolicyTypeDef,
    InventoryRetrievalJobInputTypeDef,
    PaginatorConfigTypeDef,
    ListJobsInputRequestTypeDef,
    ListMultipartUploadsInputRequestTypeDef,
    UploadListElementTypeDef,
    ListPartsInputMultipartUploadPartsTypeDef,
    ListPartsInputRequestTypeDef,
    PartListElementTypeDef,
    ListProvisionedCapacityInputRequestTypeDef,
    ProvisionedCapacityDescriptionTypeDef,
    ListTagsForVaultInputRequestTypeDef,
    ListVaultsInputRequestTypeDef,
    PurchaseProvisionedCapacityInputRequestTypeDef,
    RemoveTagsFromVaultInputRequestTypeDef,
    ServiceResourceAccountRequestTypeDef,
    ServiceResourceArchiveRequestTypeDef,
    ServiceResourceJobRequestTypeDef,
    ServiceResourceMultipartUploadRequestTypeDef,
    ServiceResourceNotificationRequestTypeDef,
    ServiceResourceVaultRequestTypeDef,
    UploadArchiveInputRequestTypeDef,
    UploadArchiveInputVaultUploadArchiveTypeDef,
    UploadMultipartPartInputMultipartUploadUploadPartTypeDef,
    UploadMultipartPartInputRequestTypeDef,
    VaultArchiveRequestTypeDef,
    VaultJobRequestTypeDef,
    VaultMultipartUploadRequestTypeDef,
    ArchiveCreationOutputTypeDef,
    CreateVaultOutputTypeDef,
    DescribeVaultOutputResponseMetadataTypeDef,
    EmptyResponseMetadataTypeDef,
    GetJobOutputOutputTypeDef,
    GetVaultLockOutputTypeDef,
    InitiateJobOutputTypeDef,
    InitiateMultipartUploadOutputTypeDef,
    InitiateVaultLockOutputTypeDef,
    InventoryRetrievalJobDescriptionResponseMetadataTypeDef,
    ListTagsForVaultOutputTypeDef,
    PurchaseProvisionedCapacityOutputTypeDef,
    UploadMultipartPartOutputTypeDef,
    InputSerializationTypeDef,
    OutputSerializationTypeDef,
    DataRetrievalPolicyTypeDef,
    DescribeVaultInputVaultExistsWaitTypeDef,
    DescribeVaultInputVaultNotExistsWaitTypeDef,
    ListVaultsOutputTypeDef,
    GetVaultAccessPolicyOutputTypeDef,
    SetVaultAccessPolicyInputRequestTypeDef,
    GetVaultNotificationsOutputTypeDef,
    SetVaultNotificationsInputNotificationSetTypeDef,
    SetVaultNotificationsInputRequestTypeDef,
    GrantTypeDef,
    InitiateVaultLockInputRequestTypeDef,
    ListJobsInputListJobsPaginateTypeDef,
    ListMultipartUploadsInputListMultipartUploadsPaginateTypeDef,
    ListPartsInputListPartsPaginateTypeDef,
    ListVaultsInputListVaultsPaginateTypeDef,
    ListMultipartUploadsOutputTypeDef,
    ListPartsOutputTypeDef,
    ListProvisionedCapacityOutputTypeDef,
    SelectParametersResponseMetadataTypeDef,
    SelectParametersTypeDef,
    GetDataRetrievalPolicyOutputTypeDef,
    SetDataRetrievalPolicyInputRequestTypeDef,
    S3LocationTypeDef,
    OutputLocationResponseMetadataTypeDef,
    OutputLocationTypeDef,
    GlacierJobDescriptionResponseMetadataTypeDef,
    GlacierJobDescriptionTypeDef,
    JobParametersTypeDef,
    ListJobsOutputTypeDef,
    InitiateJobInputRequestTypeDef,
)

def get_structure() -> AbortMultipartUploadInputRequestTypeDef:
    return {
      ...
    }
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers a drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-glacier` version is the same as related `aiobotocore`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_glacier/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
